/***************************************************************************
Name: Object Dump
Version: 1.0
Description: Complete JavaScript Object Reference
Author: Jason Karl Davis
Homepage: http://www.jasonkarldavis.com/
Email: jasonkarldavis@gmail.com

Copyright (C) 2005 Jason Karl Davis

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/





function dump(objectStr) {
	var error = top.jsvObjRef.getSt('jsview.Error');
	var display = top.jsvObjRef.getSt('jsview.Display');
	var members = top.jsvObjRef.getSt('jsview.Members');

	while (dump.area.hasChildNodes()) {
		dump.area.removeChild(dump.area.lastChild);
	}

	dump.status.value = objectStr;
	var object = eval(objectStr);
	var row, cell, count = 0;

	for (var property in object) {
		if (property=='title' && object!='document') continue;
		++count;
		row = dump.area.insertRow(-1);
		if (count % 2 == 0) row.className = "even";
		cell = row.insertCell(0);
		cell.appendChild(document.createTextNode(property));
		cell = row.insertCell(1);
		try {
			cell.appendChild(document.createTextNode(object[property]));
		} catch(e) {
			cell.appendChild(document.createTextNode(error));
			row.className = "error";
		}

		row.onclick = (function(property) {
			return function() {
				//dump(objectStr + '["' + property + '"]');
				window.location.href = "jsviewObjRef.htm?" + escape(objectStr + '["' + property + '"]');
			}
		})(property);

		row.onmouseover = (function(property) {
			return function() {
				window.status = display + " " + objectStr + '["' + property + '"]';
			}
		})(property);
	}

	var parent = objectStr.replace(/\["[^"]+"\]$/, "");
	if (parent == objectStr) {
		parent = parent.replace(/\.[^.]+$/, "");
	}
	dump.area.parentNode.tFoot.rows[0].cells[0].firstChild.nodeValue = count + " " + members;
	dump.area.parentNode.tFoot.rows[0].onclick = function() {
		window.location.href = "jsviewObjRef.htm?" + escape(parent);
	}
	dump.area.parentNode.tFoot.rows[0].onmouseover = function() {
		window.status = display + " " + parent;
	}
	top.jsvObjRef.parentObj = parent;
}

function changeLoc(arg) {
	if (arg=='scripts') {
		window.location.href = 'jsviewObjRef.htm?' + escape("top.frames[1].document.getElementsByTagName('script')");
	} else {
		window.location.href = 'jsviewObjRef.htm?' + escape("top.frames[1]");
	}
}

window.onload = function() {
	dump.area = document.getElementsByTagName("table")[0].tBodies[0];
	dump.status = document.getElementById("jsobject");
	if (location.search.length > 1) {
		dump.status.value = unescape(location.search.substr(1));
	}
	dump(dump.status.value);
}