/***************************************************************************
Name: JSView
Version: 1.1.7
Description: Allows you to view the source code of external js and css files
Author: Ron Beckman
Homepage: http://scorpiondb.com/firefox/extensions/jsview/
Email: scorpiondb@scorpiondb.com

Copyright (C) 2005  Ron Beckman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/



window.addEventListener('load',jsviewSourceLoad,false);

function jsviewSourceLoad() {
	var toolbar = document.getElementById('viewmenu-popup');
	var jstoolbar = document.getElementById("jsview-toolbar-popup");
	var csstoolbar = document.getElementById("cssview-toolbar-popup");

	if (toolbar && jstoolbar && csstoolbar) {
		toolbar.addEventListener("popupshowing", jsviewListen.TL, false);
		jstoolbar.addEventListener("popupshowing", jsviewListen.JSTL, false);
		csstoolbar.addEventListener("popupshowing", jsviewListen.CSSTL,false);
	} else {
		document.getElementById('jsview-toolbar-menu').setAttribute('hidden',true);
		document.getElementById('cssview-toolbar-menu').setAttribute('hidden',true);
	}
}


var jsviewVS = {

	command: function(arg) {
		var win = this.getMainWin();
		if (arg=='jsviewOpenAllJS') {
			win.jsview.jsviewOpenAllJS();
		} else if (arg=='jsviewOpenAllCSS') {
			win.jsview.jsviewOpenAllCSS();
		} else {
			win.jsview.jsviewMain(arg);
		}
	},

	getMainWin: function() {
		return Components.classes["@mozilla.org/appshell/window-mediator;1"].
		getService(Components.interfaces.nsIWindowMediator).
		getMostRecentWindow("navigator:browser");
	},

	getSt: function(name) {
		var win = this.getMainWin();
		var strbdl = win.document.getElementById("jsview-bundle");
		var msg = strbdl.getString(name);
		return msg;
	},

	main: function() {
		var win = this.getMainWin();
		win.jsview.startProcess(window.arguments[0]);
	},

	jsviewToolbar: function() {
		var js = this.isJSExternal();
		var css = this.isCSSExternal();
		var jstoolbar = document.getElementById('jsview-toolbar-menu');
		var csstoolbar = document.getElementById('cssview-toolbar-menu');

		if (js.length > 0) {
			jstoolbar.setAttribute('hidden',false);
			jstoolbar.setAttribute('label',this.getSt('jsview.ExtJs')+" (" +js.length+ ")");
		} else {
			jstoolbar.setAttribute('hidden',true);
		}

		if (css.length > 0) {
			csstoolbar.setAttribute('hidden',false);
			csstoolbar.setAttribute('label',this.getSt('jsview.ExtCss')+" (" +css.length+ ")");
		} else {
			csstoolbar.setAttribute('hidden',true);
		}
	},

	jsviewJSToolbar: function() {
		var i,name,temp;
		var js = this.isJSExternal();
		var jstools = document.getElementById('jsview-toolbar-popup');

		while (jstools.firstChild) {
			jstools.removeChild(jstools.firstChild);
		}

		if (js.length > 0) {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','toolbar-viewalljs');
			temp.setAttribute('label',this.getSt('jsview.ViewAllJs'));
			temp.setAttribute('oncommand',"jsviewVS.command('jsviewOpenAllJS')");
			temp.setAttribute('image','chrome://jsview/skin/js.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.ViewAllJs'));
			temp.setAttribute('style','font-weight:900;');
			temp.setAttribute('class','menuitem-iconic');
			jstools.appendChild(temp);

			for (i=0; i<js.length; ++i) {
				name = js[i].substr(js[i].lastIndexOf('/')+1);
				temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsviewVS.command('"+js[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/js.gif');
				temp.setAttribute('tooltiptext',js[i]);
				temp.setAttribute('statustext',js[i]);
				temp.setAttribute('class','menuitem-iconic');
				jstools.appendChild(temp);
			}
		} else {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','jsview-toolbar-item-nf');
			temp.setAttribute('label',this.getSt('jsview.JsNF'));
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.JsNF'));
			temp.setAttribute('class','menuitem-iconic');
			temp.setAttribute('disabled','true');
			jstools.appendChild(temp);
		}
	},

	jsviewCSSToolbar: function() {
		var i,name,temp;
		var css = this.isCSSExternal();
		var csstools = document.getElementById('cssview-toolbar-popup');

		while (csstools.firstChild) {
			csstools.removeChild(csstools.firstChild);
		}

		if (css.length > 0) {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','toolbar-viewallcss');
			temp.setAttribute('label',this.getSt('jsview.ViewAllCss'));
			temp.setAttribute('oncommand',"jsviewVS.command('jsviewOpenAllCSS')");
			temp.setAttribute('image','chrome://jsview/skin/css.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.ViewAllCss'));
			temp.setAttribute('style','font-weight:900;');
			temp.setAttribute('class','menuitem-iconic');
			csstools.appendChild(temp);

			for (i=0; i<css.length; ++i) {
				name = css[i].substr(css[i].lastIndexOf('/')+1);
				temp = document.createElement('menuitem');
				temp.setAttribute('id',name+i);
				temp.setAttribute('label',name);
				temp.setAttribute('oncommand',"jsviewVS.command('"+css[i]+"')");
				temp.setAttribute('image','chrome://jsview/skin/css.gif');
				temp.setAttribute('tooltiptext',css[i]);
				temp.setAttribute('statustext',css[i]);
				temp.setAttribute('class','menuitem-iconic');
				csstools.appendChild(temp);
			}
		} else {
			temp = document.createElement('menuitem');
			temp.setAttribute('id','cssview-toolbar-item-nf');
			temp.setAttribute('label',this.getSt('jsview.CssNF'));
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.CssNF'));
			temp.setAttribute('class','menuitem-iconic');
			temp.setAttribute('disabled','true');
			csstools.appendChild(temp);
		}
	},

	isJSExternal: function() {
		var win = this.getMainWin();
		var loc = win.content.document.location.href;
		var scriptarray = [];
		var j,i,m,ext;

		var allscripts = win.content.document.getElementsByTagName('script');
		if (allscripts[0]) {
			for (i=0; i<allscripts.length; ++i) {
				if (allscripts[i].src && allscripts[i].src!=loc) {
					ext = allscripts[i].src.substr(allscripts[i].src.lastIndexOf('.'));
					if (ext!='.cgi') scriptarray.push(allscripts[i].src);
				}
			}
		}

		var pages = win.content.parent.frames;
		if (pages.length > 0) {
			for (m=0; m<pages.length; ++m) {
				var allscripts = pages[m].document.getElementsByTagName('script');
				if (allscripts[0]) {
					for (i=0; i<allscripts.length; ++i) {
						if (allscripts[i].src && allscripts[i].src!=loc) {
							ext = allscripts[i].src.substr(allscripts[i].src.lastIndexOf('.'));
							if (ext!='.cgi') scriptarray.push(allscripts[i].src);
						}
					}
				}
			}
		}

		//check for duplicate entries and remove them
		scriptarray.sort();
		for (i=0; i<scriptarray.length-1; ++i) {
			while (scriptarray[i]==scriptarray[i+1]) {
				scriptarray.splice(i,1);
			}
		}

		return scriptarray;
	},

	isCSSExternal: function() {
		var win = this.getMainWin();
		var loc = win.content.document.location.href;
		var cssarray = [];
		var j,i,m;

		var sheets = win.content.document.styleSheets;
		if (sheets.length > 0) {
			for (i=0; i<sheets.length; ++i) {
				if (sheets[i].href && sheets[i].href!=loc) {
					cssarray.push(sheets[i].href);
				}
				cssarray = cssarray.concat(this.importedCSS(sheets[i]));
			}
		}

		var pages = win.content.parent.frames;
		if (pages.length > 0) {
			for (m=0; m<pages.length; ++m) {
				var sheets = pages[m].document.styleSheets;
				if (sheets.length > 0) {
					for (i=0; i<sheets.length; ++i) {
						if (sheets[i].href && sheets[i].href!=loc) {
							cssarray.push(sheets[i].href);
						}
						cssarray = cssarray.concat(this.importedCSS(sheets[i]));
					}
				}
			}
		}

		//check for duplicate entries and remove them
		cssarray.sort();
		for (i=0; i<cssarray.length-1; ++i) {
			while (cssarray[i]==cssarray[i+1]) {
				cssarray.splice(i,1);
			}
		}

		return cssarray;
	},

	importedCSS: function(css) {
		var j;
		var cssarray = [];
		var rules = css.cssRules;
		for (j=0; j<rules.length; ++j) {
			if (rules[j].type==3) {
				cssarray.push(rules[j].styleSheet.href);
				cssarray = cssarray.concat(this.importedCSS(rules[j].styleSheet));
			} else { break; }
		}
		return cssarray;
	}
};

var jsviewListen = {
	TL: function() {
		jsviewVS.jsviewToolbar();
	},

	JSTL: function() {
		jsviewVS.jsviewJSToolbar();
	},

	CSSTL: function() {
		jsviewVS.jsviewCSSToolbar();
	}
};